<%
/**
 * An admin include file that facilitates product modification.
 *
 * @Author  - Kyle McIntyre
 * @Version - 6.3.05
 */
%>

<%
    // Check for and handle MIME form submission
    if (MultipartFormDataRequest.isMultipartFormData(request))
    {
        MultipartFormDataRequest mr = new MultipartFormDataRequest(request);    
        edit_id = mr.getParameter("edit_id");

        // Attempt to process the modifications
        Enumeration columns = mr.getParameterNames(); 
        while (columns.hasMoreElements())
        {
             String column = (String)columns.nextElement();
             if (!mr.getParameter(column).equals("") && !column.equals("delete") && !column.equals("icon") 
                 && !column.equals("edit_id") && !column.equals("rating") && !column.equals("action"))
             {
	     	 // Escape single quotes to preserve SQL integrity
                 form.setValue(column, mr.getParameter(column).replace("'", "\\'"));
             }
        } 

        // Check for and process delete requests. 
        if (mr.getParameter("delete") != null)
        {
            // Delete the product from the database
            query = "DELETE FROM products WHERE product_id = '" + edit_id + "';";

            if (db.update(query) > 0)
            {
                out.println("Product deleted successfully. <br />");
                form.empty(); 
            }
            else
                out.println("Product deletion failed. (Internal Error)");                
        }
        else if (form.size() == MODIFY_FORM_SIZE && util.checkForms(form))
        {
            // Form filled out correctly. Process the query. 
            query = "UPDATE products SET ";
               
            for (int i = 0; i < form.size(); i++)
            {
                query += form.getKey(i) + " = '" + form.getValue(i) + "'";
                if (i < form.size() - 1)
                    query += ", ";
                else
                    query += " ";
            }

            if (mr.getParameter("rating") != null && mr.getParameter("rating").equals("on"))
                query += ", rating = '0', ratings = '0' "; 

            // Handle image icon upload using the javazoom bean. 

            Hashtable files = mr.getFiles();
            if (((UploadFile)mr.getFiles().get("icon")).getFileName() != null)
            {
	        // Calculate and examine the file's extension
                String file_name = ((UploadFile)mr.getFiles().get("icon")).getFileName();
 	        int index = file_name.length() - 1;
		while (file_name.charAt(index) != '.')
		    index--;
		    
		String extension = file_name.substring(index, file_name.length());
		
                // Don't upload non image files for security reasons. 
		if (extension.equalsIgnoreCase(".jpg") || extension.equalsIgnoreCase(".gif"))
		{
		    // Safe file extension, process the upload. 
                    UploadFile ufile = (UploadFile)files.get("icon");
                    long name = System.currentTimeMillis();
                    ufile.setFileName(name + extension);
                    UploadBean ub = new UploadBean();
                    ub.setStoremodel(UploadBean.FOLDERSTORE);
                    ub.setFolderstore("C:\\Program Files\\Apache Software Foundation\\Tomcat 5.5\\webapps\\ROOT\\movies\\images\\icons");
                    ub.store(mr, "icon");
                    query += ", icon = '" + IMG_DIRECTORY + name + extension + "' ";
		}
            }       

            query += "WHERE product_id = '" + edit_id + "';";

            if (db.update(query) > 0)
                out.println("Product modification succesful.<br />");
            else
                out.println("Product modification failed. (Internal Error)<br />");
        }
        else
        {
            if (form.size() > 0 && form.size() != MODIFY_FORM_SIZE)
                out.println("Product modification failed. Please ensure every form element has a value. However, you have the option of not specifying a new image icon.<br />");
            else 
                out.println("Product modification failed. Some fields contained incorrect values.<br />");
        }
    }
    else
        out.println("Here you can modify product information. Simply specify the product_id of the product you wish to modify and click Edit. Use the listing and search pages if you don't know the product's ID number. <br />");
        
    // Allow user to specify a product to edit
%>

    <form action="product_manager.jsp?action=modify" method="post">
      Please specify a product to modify by entering a product_id: 
      <input type="text" name="edit_id" size="4" value="<%= edit_id %>" />
      <input type="submit" value="Edit" />
    </form>

<%
    // Gather information about the product that is currently being edited. 
    query = "SELECT * FROM products WHERE product_id = '" + edit_id + "';";
    result = db.query(query);

    if (result.next())
    {
        ResultSetMetaData rsmd = result.getMetaData();
        for (int i = 1; i <= rsmd.getColumnCount(); i++)
        {
            String column = rsmd.getColumnName(i);
            if (!column.equals("edit_id"))
                form.setValue(column, result.getString(i));
        }
        out.println("<b>Currently editing product_id " + edit_id + ".</b><br /><br />");
    }        
    else 
        out.println("Sorry, but the specified product does not exist. Please try again.<br />");
%>