<%
/**
 * A file that facilitates general store management, including sales summaries,
 * price control, rental check-ins, and mass emailing.
 *
 * @Author  - Kyle McIntyre
 * @Version - 6.3.05
 */
%>


<%@ page import="java.sql.ResultSet"         %>
<%@ page import="java.sql.Date"              %>
<%@ page import="java.sql.ResultSetMetaData" %>
<%@ page import="java.util.Enumeration"      %>
<%@ page import="java.text.NumberFormat"     %>

<jsp:useBean id="util" class="mcintyr.edu.montana.cs.esus.Utilities"          scope="session" />
<jsp:useBean id="db"   class="mcintyr.edu.montana.cs.esus.DatabaseConnection" scope="session" />
<jsp:useBean id="user" class="mcintyr.edu.montana.cs.esus.User"               scope="session" />
<jsp:useBean id="form" class="mcintyr.edu.montana.cs.esus.AssociativeArray"   scope="page"    />

<%
    // Ensure user is an admin (no falsified URLs)
    if (!user.getValue("user_type").equals("admin"))
        response.sendRedirect(response.encodeRedirectURL("/movies/index.jsp"));
%>

<%@ include file="/movies/include/header.tpl"     %>
<%@ include file="/movies/include/navigation.jsp" %>

<div class="page">
  Store Manager: 
  <a href="store_manager.jsp?action=prices">Price Control</a> |
  <a href="store_manager.jsp?action=sales">Sales Information</a> |
  <a href="store_manager.jsp?action=check_in">Rental Check-In</a> |
  <a href="store_manager.jsp?action=low_stock">Low Stock  </a> 
  <hr />

<%
    // Create a number formatter for all of the include pages to share.
    NumberFormat nf = NumberFormat.getInstance();
    nf.setMinimumFractionDigits(2);
    nf.setMaximumFractionDigits(2);
    
    String action = request.getParameter("action");
    if (action == null)
        action = "prices";
    
    // Include necessary file based on the page action. 
    if (action.equals("prices"))
    {
        %><%@ include file="store_prices.jsp" %><%
    }
    else if (action.equals("sales"))
    {
        %><%@ include file="store_sales.jsp" %><%
    }
    else if (action.equals("check_in"))
    {
        %><%@ include file="store_check_in.jsp" %><%
    }
    else // if (action.equals("low_stock"))
    {
        %><%@ include file="store_low_stock.jsp"%><%
    }
%>
</div>

<%@ include file="/movies/include/footer.tpl"     %>
