<%
/**
 * An admin include file that facilitates user addition.
 *
 * @Author  - Kyle McIntyre
 * @Version - 6.3.05
 */
%>

<%
    // Handle possible form submission
    if (request.getParameter("form_set") != null)
    {      
        // Load in all POST variables related to form submission
        Enumeration columns = request.getParameterNames(); 
        while (columns.hasMoreElements())
        {
            String column = (String)columns.nextElement();
            if (!request.getParameter(column).equals("") && !column.equals("submit") 
                && !column.equals("form_set") && !column.equals("edit_id") && !column.equals("action")
                    && (action.equals("add") || !column.equals("password")))
            {    
	        // Escape single quotes to preserve SQL integrity
                form.setValue(column, request.getParameter(column).replace("'", "\\'"));
	    }
        } 

        // Ensure form was completely and correctly filled out. 
        if (form.size() == ADD_FORM_SIZE && util.checkForms(form) && util.isLoginUnique(form.getValue("login")))
        {
            // Form filled out correctly. Insert new user into database.

            // Encrypt the password
            MessageDigest md = MessageDigest.getInstance("MD5");
            md.update(form.getValue("password").getBytes());
            form.setValue("password", new String(md.digest()));

            String query = "INSERT INTO users (";

            for (int i = 0; i < form.size(); i++)
            {
                query += form.getKey(i);
                if (i < form.size() - 1)
                    query += ", ";
            }
 
            query += ") VALUES(";
        
            for (int i = 0; i < form.size(); i++)
            {
                query += "'" + form.getValue(i) + "'"; 
                if (i < form.size() - 1)
                    query += ", ";
            }

            query += ");";

            if (db.update(query) > 0)
                out.println("User added successfully. <br />");
            else
                out.println("User addition failed. <br />");
        }
        else
        {
            if (form.size() > 0 && form.size() != ADD_FORM_SIZE)
                out.println("Product modification failed. Please ensure every form element has a value. However, you have the option of not specifying a new image icon.<br />");
            else 
                out.println("Product modification failed. Some fields contained incorrect values.<br />");
        }
    }
    out.println("<br />Add a new user: <br />");
%>