<%
/**
 * A file that examines a user's shopping cart and processes
 * orders for any items that are present.
 *
 * @Author  - Kyle McIntyre
 * @Version - 6.1.05
 */
%>

<%@ page import="java.sql.ResultSet"         %>
<%@ page import="java.sql.ResultSetMetaData" %>
<%@ page import="java.util.StringTokenizer"  %>
<%@ page import="java.text.NumberFormat"     %>

<jsp:useBean id="util"   class="mcintyr.edu.montana.cs.esus.Utilities"          scope="session" />
<jsp:useBean id="db"     class="mcintyr.edu.montana.cs.esus.DatabaseConnection" scope="session" />
<jsp:useBean id="user"   class="mcintyr.edu.montana.cs.esus.User"               scope="session" />

<%@ include file="/movies/include/header.tpl"     %>
<%@ include file="/movies/include/navigation.jsp" %>

<div class="page">
<b>Check-Out</b>
<br />

<%
    // Create a number formatter
    NumberFormat nf = NumberFormat.getInstance();
    nf.setMinimumFractionDigits(2);
    nf.setMaximumFractionDigits(2);
    
    // Check for items in the cart
    if (!user.getValue("cart").equals(""))
    {

%>
The following items were found in your shopping cart. Please review the items and place a check next to those that you would like to rent from McMovies. When you are finished reviewing the products, please click Proceed.
<br />
<br />

<%
        // Ensure the user is logged in
        if (!user.getValue("user_type").equals("admin") && !user.getValue("user_type").equals("enduser"))
             response.sendRedirect(response.encodeRedirectURL("/movies/public/login.jsp"));

        // Grab the products associated with items in the user's cart. 
        String query = "SELECT title, product_id, f.fee_value FROM products, fees f WHERE f.fee_name = fee_type AND (";
        StringTokenizer toke = new StringTokenizer(user.getValue("cart"), ",");
        while (toke.hasMoreTokens())
        {
            if (toke.countTokens() > 1)
                query += "product_id = '" + toke.nextToken() + "' OR ";
            else
                query += "product_id = '" + toke.nextToken() + "');";
        }
        ResultSet result = db.query(query);
        ResultSetMetaData rsmd = result.getMetaData();
%>

<form action="purchase.jsp" method="post">
  <table width="90%">
    <tr>
      <th align="left"><br /></th>
      <th align="left">Movie</th>
      <th align="left">Fee</th>
    </tr>

<%
        // Display the products that are in the cart. 
        // Allow the user to choose which items to keep. 
        while (result.next())
        {
%>

    <tr>
      <td><input type="checkbox" name="<%= result.getString("product_id") %>" /></td>
      <td><%= result.getString("title") %></td>
      <td>$<%= nf.format(result.getFloat("f.fee_value"))%></td>
    </tr>

<%
        }
%>

  </table>
  <br />
  <input type="submit" value="Proceed" />
</form>

<%
    }
    else
    {
        out.println("Your cart is currently empty. Follow the \"View Products\" link to find movies that you would like to rent. <br />"); 
    }  
%>

</div>

<%@ include file="/movies/include/footer.tpl"     %>