<%
/**
 * A file that processes new orders and adds them to
 * the database. The user is then cordially thanked.
 *
 * @Author  - Kyle McIntyre
 * @Version - 6.1.05
 */
%>

<%@ page import="java.util.StringTokenizer" %>
<%@ page import="java.sql.ResultSet"        %>
<%@ page import="java.sql.Date"             %>


<jsp:useBean id="util" class="mcintyr.edu.montana.cs.esus.Utilities"          scope="session" />
<jsp:useBean id="db"   class="mcintyr.edu.montana.cs.esus.DatabaseConnection" scope="session" />
<jsp:useBean id="user" class="mcintyr.edu.montana.cs.esus.User"               scope="session" />
<jsp:useBean id="form" class="mcintyr.edu.montana.cs.esus.AssociativeArray"   scope="page"    />

<%@ include file="/movies/include/header.tpl"     %>
<%@ include file="/movies/include/navigation.jsp" %>

<%!
    // The current check-out duration. This value should eventually
    // be incorporated into a SQL table & managed on the admin-side. 
    private static final int DAYS = 3;
%>


<div class="page">

<%
    // Ensure that the user elected to buy something.
    if (!user.getValue("order").equals(""))
    {
        StringTokenizer toke = new StringTokenizer(user.getValue("order"), ",");
        int orders = 0;
        
        // Attempt to process all requested items. 
        while (toke.hasMoreTokens())
        {
            String product_id = toke.nextToken();

            /*
             * It is possible that two users have the same item in the cart, hence we
             * must check again to ensure the product is actually available!
             */

            String query = "SELECT p.title, p.rentals, p.in_stock, p.product_id, f.fee_value FROM products p, fees f WHERE p.product_id = '" + product_id + "' AND p.fee_type = f.fee_name;";
            ResultSet result = db.query(query);
            result.next(); 
	    float price  = result.getFloat("f.fee_value");
            int rentals  = result.getInt("rentals") + 1;
            int in_stock = result.getInt("in_stock") - 1;
	    
            // Make sure requested items are still in stock. 
            if (in_stock >= 0)
            {
                // Title is in stock, adjust the product database to reflect the order.
                query = "UPDATE products SET rentals = '" + rentals + "', in_stock = '" + in_stock + "' WHERE product_id = '" + product_id + "';";
                db.update(query);
		
                // Process the order by adding a new row to the orders table. 
                query = "INSERT INTO orders(product_id, user_id, due_date, returned, fee, date) " + 
	                "VALUES('" + product_id + "', '" + user.getValue("user_id") + "', '" + (new Date(System.currentTimeMillis() + DAYS * 24 * 60 * 60 * 1000)).toString() + "', '0', '" + price + "', '" + new Date(System.currentTimeMillis()) + "');";
                orders += db.update(query);

                // Clear out the user's shopping cart and order variables.
                // This prevents inadvertent repeat check-outs. 
                user.setValue("cart", "");
                user.setValue("order", "");
            } 
            else
                out.println("Sorry, <i>" + result.getString("title") + "</i> is out of stock. <br />");
        }

        if (orders > 0)
        {
%>
    <b>Thank You</b>
    <hr />
    Thank You for your purchase! Your delivery should arrive within 20 minutes. We hope you enjoy the show! Please note that
    the title is due back to McMovies within three days. Thanks again!<br /><br />
    
<%
        }
        else
            out.println("Order failed. (Internal Error)<br />");      
    }
    else
        out.println("ERROR: You have attempted to purchase nothing. <br />");
%>

</div>

<%@ include file="/movies/include/footer.tpl"     %>