<%
/**
 * A file that allows users to review the total cost of 
 * of their purchase and proceed with the order.
 *
 * @Author  - Kyle McIntyre
 * @Version - 6.1.05
 */
%>

<%@ page import="java.sql.ResultSet"         %>
<%@ page import="java.sql.ResultSetMetaData" %>
<%@ page import="java.util.StringTokenizer"  %>
<%@ page import="java.util.Enumeration"      %>
<%@ page import="java.text.NumberFormat"     %>

<jsp:useBean id="util"   class="mcintyr.edu.montana.cs.esus.Utilities"          scope="session" />
<jsp:useBean id="db"     class="mcintyr.edu.montana.cs.esus.DatabaseConnection" scope="session" />
<jsp:useBean id="user"   class="mcintyr.edu.montana.cs.esus.User"               scope="session" />
<jsp:useBean id="form"   class="mcintyr.edu.montana.cs.esus.AssociativeArray"   scope="page"    />

<%@ include file="/movies/include/header.tpl"     %>
<%@ include file="/movies/include/navigation.jsp" %>

<div class="page">

<%
    // Create a number formatter
    NumberFormat nf = NumberFormat.getInstance();
    nf.setMinimumFractionDigits(2);
    nf.setMaximumFractionDigits(2);
    
    // Ensure user has items in his or her cart
    if (!user.getValue("cart").equals(""))
    {
        // Ensure the user is logged in
        if (!user.getValue("user_type").equals("admin") && !user.getValue("user_type").equals("enduser"))
            response.sendRedirect(response.encodeRedirectURL("/movies/public/register.jsp"));

        // Load in all POST variables
        Enumeration columns = request.getParameterNames(); 
        while (columns.hasMoreElements())
        {
            String column = (String)columns.nextElement();
            if (!request.getParameter(column).equals(""))
               form.setValue(column, request.getParameter(column));
        } 

        // Ensure the user explicitly chose to rent specific items on the last page. 
        if (form.size() > 0)
        {
%>
  By clicking "Buy" you agree to our terms of service, which require that you pay 
  upon delivery and return the movie within 3 days time. 
  You have elected to rent the following titles from McMovies: 
<%
            // Generate a SQL query to extract the requested items from the products table. 
 
            String query = "SELECT title, product_id, f.fee_value FROM products, fees f WHERE fee_type = f.fee_name AND (";
            StringTokenizer toke = new StringTokenizer(user.getValue("cart"), ",");

            while (toke.hasMoreTokens())
            {
                String token = toke.nextToken();
                if (request.getParameter(token) != null)
                {
                    query += "product_id = '" + token + "' OR ";
                    user.setValue("order", user.getValue("order") + token + ",");
                }
            }

            // Remove the last (erroneous) OR
            query = query.substring(0, query.length() - 3);
	    query += ");";

            ResultSet result = db.query(query);
            ResultSetMetaData rsmd = result.getMetaData();

            float sum = 0;
%>

<form action="process.jsp" method="post">
  <table width="90%">
    <tr>
      <th align="left">Movie</th>
      <th align="left">Fee</th>
    </tr>

<%
            // Display the resulting products. 

            while (result.next())
            {
                sum += result.getFloat("f.fee_value");
%>

    <tr>
      <td><%= result.getString("title") %></td>
      <td>$<%= nf.format(result.getFloat("f.fee_value")) %></td>
    </tr>

<%
            }
%>
    <tr>
      <td colspan="2"><br /></td>
    </tr>
    <tr>
      <th align="left">Total:</th>
      <td>$<%= nf.format(sum) %></td>
    </tr>
  </table>
  <br />
  
  <input type="submit" value="Buy" />
</form>

<% 
        }
        else
            out.println("You did not elect to purchase any rentals from McMovies. <br />"); 
    }
%>

</div>

<%@ include file="/movies/include/footer.tpl"     %>